#include "wedel.h"

Bits bits;

int hcf(int n1,int n2) { int n3=n1%n2; if (n3) return hcf(n2,n3); return n2; }

// ----------   Graph stuff - Nodes, edges  -------------

int n_edges, n_nodes, n_vehicles;
Edge E[2000]; Node N[2000]; Vehicle V[200];

  void Node::operator + (Edge &e1)  {  e[ne++] = &e1;  }
  void Node::operator - (Edge *e1)
  {
    for (int j=0;j<ne; j++)
      if (e[j]==e1) e[j]=e[--ne];
  }

  bool Node::is_neighbour(Node *n)
  {
    for (int j=0;j<ne;j++)
      if (e[j]->n1==n || e[j]->n2==n) return true;
    return false;
  }

  int Node::ne_type(int t)
  {
    int n,j;
    for (n=j=0;j<ne;j++)
      if (e[j]->type==t) n++;
    return n;
  }

Node &new_node(fix x1,fix y1)
{
  Node &n=N[n_nodes];
  n.id=n_nodes++;
  n.ne=0; n.x=x1; n.y=y1;
  return n;
}

void delete_node(int i)
{
  if (N[i].ne) return;
  if (i<--n_nodes)
    N[i]=N[n_nodes];
  N[i].id=i;
}
void delete_edge(Edge &e)
{
  *e.n1 - &e; *e.n2 - &e;
  e = E[--n_edges];
}

int num_edges(Edge &e) { return e.n1->ne + e.n2->ne; }

bool has_leaf(Edge &e) { return e.n1->ne==1 || e.n2->ne==1; }

Edge &join(Node *n1,Node *n2,int type)
{
  fix x1,y1;
  Edge &e=E[n_edges++];
  e.n1=n1; e.n2=n2;
  e.type=type;
  *n1 + e; *n2 + e;
  x1=n2->x-n1->x; y1=n2->y-n1->y;
  e.l=sqrt(SQ((int)x1)+SQ((int)y1));
  e.dir=atan2(y1,x1);
  e.x=(n1->x+n2->x)/2; e.y=(n1->y+n2->y)/2;
  return e;
}
Edge &join(Node &n1,Node &n2,int type) { return join(&n1,&n2,type); }


// -----------    graph save/load -----------

void save_graph()
{
  FILE *f1;
  int j;
  f1=fopen("nodes.csv","w");
  for (j=0;j<n_nodes;j++) {
    fprintf(f1,"%d,%d\n",N[j].x.v,N[j].y.v);
  }
  fclose(f1);

  f1=fopen("edges.csv","w");
  for (j=0;j<n_edges;j++) {
    Edge &e=E[j];
    fprintf(f1,"%d,%d,%d\n",e.n1->id,e.n2->id,e.type);
  }
  fclose(f1);
}

void load_graph()
{
  int i1,i2,i3;
  FILE *f1;
  fix x,y;

  n_nodes=n_edges=0;

  f1=fopen("nodes.csv","r");
  while (fscanf(f1,"%d,%d\n",&x.v,&y.v)==2)
    new_node(x,y);
  fclose(f1);

  f1=fopen("edges.csv","r");
  while (fscanf(f1,"%d,%d,%d\n",&i1,&i2,&i3)==3)
    join(N[i1],N[i2],i3);
  fclose(f1);
}

// --------------- Vehicles -----------------

  void Vehicle::place()
  {
    if (!n && !e || n && e) exit(1);
    if (n) { x=n->x; y=n->y;  }
    if (e) {
      if (speed<0)  dir=e->dir+(e->dir>0 ? -128 : 128);
      else  dir=e->dir;
      x=(1-pos)*e->n1->x + pos*e->n2->x;
      y =(1-pos)*e->n1->y + pos*e->n2->y;
    }
  }
  Edge* Vehicle::choose_random()
  {
    fix d1,d2,dx1,dy1;
    int j,j2=-1;
    d2=0;
    for (j=0; j<n->ne; j++) {
      Edge &e1=*(n->e[j]);
      if (e1.type==(type==4 ? 1:2)) continue;
      dx1=(e1.x - n->x)/e1.l;
      dy1=(e1.y - n->y)/e1.l;
      d1 = dx1*cos(dir) + dy1*sin(dir);
      d1=sqrt(d1+0.5) *(int)(rand()%10+1) +1;
      if (d1>d2) { d2=d1; j2=j; }
    }
    return j2>=0 ? n->e[j2] : NULL;
  }

  Edge* Vehicle::choose_go()
  {
    fix dx,dy,d1,d2,dx1,dy1;
    int j,j2=-1;
    d2=0.3;
    if (go & stopmove) return NULL;
    if (go & leftmove) dx--;
    if (go & rightmove) dx++;
    if (go & upmove) dy--;
    if (go & downmove) dy++;
    if (dx==0 && dy==0) return NULL;
    for (j=0; j<n->ne; j++) {
      Edge &e1=*(n->e[j]);
      if (e1.type==(type==4 ? 1:2)) continue;
      dx1=(e1.x - n->x)/e1.l;
      dy1=(e1.y - n->y)/e1.l;
      d1 = dx1*dx + dy1*dy;
      if (d1>d2) { d2=d1; j2=j; }
    }
    return j2>=0 ? n->e[j2] : NULL;
  }

  void Vehicle::choose()
  {
    fix sp1;
    Edge *e2;
    if (!n) return;
    if (this==V) {
      e2=choose_go();
      if (e2) e=e2;
    } else {
      e2=choose_random();
      if (e2) e=e2;
    }
    if (e) {
      if (type==1) sp1=4;
      if (type==2) sp1=1;
      if (type==3) sp1=(this==V)? 10:6;
      if (type==4) sp1=15;
      if (e->n1==n) { pos=0; speed=sp1/e->l; }
      else { pos=1; speed=-sp1/e->l; }
      n=NULL;
    }
  }

  void Vehicle::slide()
  {
    pos+=speed;
    if (pos>=1) { n=e->n2; e=NULL; }
    if (pos<=0) { n=e->n1; e=NULL; }
  }

  void Vehicle::init(int t)
  {
    int j;
    type=t; e=NULL; go=0;
    dir=0; speed=0; pos=0.5;
    if (t==2) {
      do  e=&E[j=rand()%n_edges]; while (e->type>1);
      n=NULL;
    }  else if (t<4)
      do  n=&N[j=rand()%n_nodes]; while (!n->ne_type(1));
    else 
      do  n=&N[j=rand()%n_nodes]; while (!n->ne_type(2));
    place();
  }
