# Makefile for SpeedHack entry

# Most things here are for me to change, but anyone else may need to change things, eg the "g++" if your compiler is named differently.

# Should be 0 or 1
DEBUG = 0
# Should be Full, NoSrc, Entry, Regular
ZIPTYPE = Entry

# Put this in to redirect errors
ER = redir -e errors.txt

SRC = *.cpp *.h makef* obj/holder.txt obj_d/holder.txt
ALWAYSIN = readme.txt log.txt *.csv *.htm *.dat
RAW = *.txt
# Change this if you have a different compiler
C = g++

d_exe = a.exe
r_exe = game.exe

ifeq ($(DEBUG),1)
LIBS = -lm -lalld
CFLAGS = -Wall -g -DERIC_ALLEGRO -DDEBUG
EXE = $(d_exe)
obj_dir = obj_d/
else
LIBS = -lm -lalleg
CFLAGS = -Wall -DERIC_ALLEGRO
EXE = $(r_exe)
obj_dir = obj/
endif

ifeq ($(ZIPTYPE),Full)
INZIP = $(ALWAYSIN) $(RAW) $(SRC)
ZIP = tins_bak.zip
endif
ifeq ($(DEBUG),0)
ifeq ($(ZIPTYPE),NoSrc)
INZIP = $(ALWAYSIN) $(EXE)
ZIP = tins_nosrc.zip
endif
ifeq ($(ZIPTYPE),Regular)
INZIP = $(ALWAYSIN) $(EXE) $(SRC)
ZIP = tins.zip
endif
endif
ifeq ($(ZIPTYPE),Entry)
INZIP = $(ALWAYSIN) $(SRC)
ZIP = we_deliver.zip
endif

TXTS1 = e0 e1 e2 e3 e4 e9 t0 t1 t2 t3 t4 t5 t6 ta
TXTS = $(addsuffix .txt,$(TXTS1))

FNTS1 = cn16 cn18 cn24 cn26 cnb26
FNTS = $(addsuffix .pcx,$(FNTS1))

OBJS2 = graph menu page wedel
OBJS1 = $(addsuffix .o,$(OBJS2))
OBJS = $(addprefix $(obj_dir),$(OBJS1))

DAT1 = text.dat
DAT2 = font.dat

normal: $(EXE)


$(EXE): $(OBJS)
	$C -o $@ $(OBJS) $(LIBS)


$(obj_dir)%.o: %.cpp
	$C -c $(CFLAGS) $< -o $@

#$(DAT1): $(TXTS)
#	dat $@ -t DATA -a $? -h text.h
#$(DAT2): $(FNTS)
#	dat $@ -t FONT -a $? -h font.h

# Make clean is needed if any .h files are changed.
clean:
	rm -f *.o */*.o $(r_exe) $(d_exe) $(DAT1) $(DAT2)

ifdef INZIP
zip: $(INZIP)
	rm -f $(ZIP)
	7z a -tzip $(ZIP) $(INZIP)
else
zip:
	rem INZIP is undefined. Check that WHICHZIP and DEBUG are correctly specified.
endif
