#include "wedel.h"

  Pages pp;

  void Page::get_text(const char *s,int l1)
#define EOL(c) ((c)==10 || (c)==13)
  {
    char c;
    l = (l1<0) ? strlen(s) : l1;

    memset(a,' ',sizeof(a));

    int j,j1,x,xs=-1,y;
    for (j=x=y=0; j<l && y<height; ) {
      if (s[j]==' ') xs=x;
      if (s[j]>=' ') {
        if (x==width) {
          y++; if (y>=height) break;
          for (j1=0; j1<x-xs-1; j1++) {
            a[y][j1]=a[y-1][xs+1+j1];
            a[y-1][xs+1+j1]=' ';
          }
          x=j1;
        }
        a[y][x++]=s[j++];
      }
      else {
        if (EOL(s[j])) {
          x=0; y++; j++;
          if (j<l && EOL(s[j]) && s[j]!=s[j-1]) j++;
        }
      }
    }
    memset(hm,0,sizeof(hm));
    for (y=0;y<height;y++)
      for (x=0;x<width;x++)
        if ((c=a[y][x])!=' ')
          hm[c&255]++;
  }

  void Letter::calc(int t)
  {
    x = ((65536-t)*fx + t*tx) / 65536;
    y = ((65536-t)*fy + t*ty) / 65536;
  }



  void Pages::init(Page *a1,Page *a2)
  {
    int j,x,y,o;
    fix a;
    char m;
    p1=a1; p2=a2;
    for (j=n=0;j<256;j++) {
       hm[j]=MAX(p1->hm[j],p2->hm[j]);
       chm[j]=n;
       n+=hm[j];
    }
    memset(l,0,sizeof(l));
    for (y=0;y<p1->height;y++)
      for (x=0;x<p1->width;x++) {
        m=p1->a[y][x];
        if (m>' ') {
          for (o=chm[m&255]; l[o].fx; o++);
          l[o].l=m; l[o].fx=x*15+10; l[o].fy=y*20+10;
        }
      }
    for (y=0;y<p2->height;y++)
      for (x=0;x<p2->width;x++) {
        m=p2->a[y][x];
        if (m>' ') {
          for (o=chm[m]; l[o].tx; o++);
          l[o].l=m; l[o].tx=x*15+10; l[o].ty=y*20+10;
        }
      }
    for (j=0;j<n;j++) {
      if (!l[j].fx) {
        a.v=rand()<<9;
        l[j].fx=(int)(500*sin(a)+SCREEN_W/2);
        l[j].fy=(int)(500*cos(a)+SCREEN_H/2);
      }
      if (!l[j].tx) {
        a.v=rand()<<9; // <<9 to get proper randomness on MinGW
        l[j].tx=(int)(500*sin(a)+320);
        l[j].ty=(int)(500*cos(a)+240);
      }
    }
  }

  void Pages::draw(int t)
  {
    int j;

    for (int j=0;j<n;j++) l[j].calc(t);

    clear_to_color(buf,0);
    for (j=0; j<n; j++) {
      textprintf_ex(buf,FD(CN16),l[j].x,l[j].y,15,-1,"%c",l[j].l);
    }
    textprintf_ex(buf,FD(CN16),5,
        (t*(p2->l?430:480) + (65536-t)*(p1->l?430:480))>>16,14,-1,
        "Press C for contents, Enter to return,");
    textprintf_ex(buf,FD(CN16),5,
        (t*(p2->l?455:500) + (65536-t)*(p1->l?455:500))>>16,14,-1,
        " PgUp/PgDn for previous/next page");
    BBS;
  }

  void Pages::smove()
  {
    for (t1=0; t1<60 && !keySHIFT; ) {
      pp.draw((t1<30) ? (SQ(t1)<<15)/900 : ((1800-SQ(60-t1))<<15)/900);
    }
    pp.draw(1<<16);
  }

Page H[30];
void read_pages()
{
  int j;
  DATAFILE *T = load_datafile("text.dat");
  if (!T) exit(1);
  for (j=0; T[j].type==DAT_DATA; j++) 
    H[j].get_text((char*)T[j].dat,T[j].size);
  unload_datafile(T);

  char about_str[200];
  sprintf(about_str,"We Deliver.\n\nby Eric Love\n\nMade for TINS 2006\nCompiled%s at %s on %s\nUses Allegro %s\n",
#if __GNUC__
            " with gcc " __VERSION__,
#else
              "",
#endif
       __TIME__, __DATE__,ALLEGRO_VERSION_STR);
  H[TA_TXT].get_text(about_str);
  H[29].get_text("");

}

void help(int i)
{
  Page *p1,*p2;
  int k,pn;

#define M1(n) p2=&H[(pn=n)]
#define M2(n) Case KEY_##n: M1(T0_TXT+n);

  if (current_pal==other_pal) cross_fade(black_palette,timer_speed/2);
  set_palette1(normal_pal);

  p1=&H[29];
  if (i==-1)  M1(T0_TXT);
  else if (i>=0 && i<=TA_TXT) M1(i);
  else return;
  do {
    pp.init(p1,p2);
    pp.smove();
    p1=p2;
    while (p1==p2) {
      k=readkey()>>8;
      switch(k) {
        case KEY_ESC: case KEY_ENTER: p2=NULL;
        Case KEY_C: M1(T0_TXT);
        Case KEY_A: M1(TA_TXT);
        M2(0); M2(1); M2(2);
#undef M1
#undef M2

        Case KEY_UP: case KEY_PGUP:
          if (pn>T0_TXT && pn<=TA_TXT) p2=&H[--pn];
        Case KEY_DOWN: case KEY_PGDN:
          if (pn>=T0_TXT && pn<TA_TXT) p2=&H[++pn];
      }
    }
  } while (p2);
  pp.init(p1,&H[29]);
  pp.smove();
}
