#include "wedel.h"

volatile int t1;
int t2,t3, fts,fps=0;
int timer_speed=30;

DATAFILE *DF,*DM;

void timer_click() { t1++; }
END_OF_FUNCTION(timer_click);

PALETTE normal_pal,other_pal, xf_pal;
RGB *current_pal=NULL;
#define PAL(P,n,r1,g1,b1) { P[n].r=r1; P[n].g=g1; P[n].b=b1; }

int dd; // ugly global
// ------------------ Palettes --------------------

void make_palettes()
{
  int n;
  for (n=0;n<255;n++)
    PAL(normal_pal, n, (n&8 ? 20:0)+(n&4 ? 43:0), (n&8 ? 20:0)+(n&2 ? 43:0), (n&8 ? 20:0)+(n&1 ? 43:0))

  for (n=0;n<16;n++) {
    PAL(other_pal,n,63,57,47)
    PAL(other_pal,n+16,0,0,0)
    PAL(other_pal,n+32,63,0,0)
  }
}

void set_palette1(PALETTE p)
{
  if (current_pal!=p)
    set_palette(current_pal=p);
}

void cross_fade(PALETTE too,int length)
{
  int i;
  for (t1=0; !keySHIFT && !key[KEY_ESC] && t1<length;) {
    i=t1*64/length;
    fade_interpolate(current_pal,too,xf_pal,i,0,255);
    set_palette(xf_pal);
    while (i==t1*64/length) ;
  }
  set_palette1(too);
}

// --------------- High globals -----------------------

fix scale,OX,OY;
BITMAP *menu_buf,*buf,*asc_bmp;
int cur_node,cur_edge, close_node,close_edge;
void read_pages();
int score,deliv,era,t_limit,lives_left;
#define time_left (t_limit-t2)
int riding;

// ---------- Internal Allegro stuff --------------------

typedef struct FONT_MONO_DATA 
{
   int begin, end;                  /* first char and one-past-the-end char */
   FONT_GLYPH **glyphs;             /* our glyphs */
   struct FONT_MONO_DATA *next;     /* linked list structure */
} FONT_MONO_DATA;

FONT_GLYPH* mono_find_glyph(AL_CONST FONT* f, int ch)
{
    FONT_MONO_DATA* mf = (FONT_MONO_DATA*)(f->data);
    while(mf) {
        if(ch >= mf->begin && ch < mf->end) return mf->glyphs[ch - mf->begin];
        mf = mf->next;
    }
    if(ch != allegro_404_char) return mono_find_glyph(f, allegro_404_char);
    return 0;
}

// -------------------- Init ---------------------------

void init(int vm)
{
  int j;

  allegro_init();

  install_keyboard();
  install_timer();

  install_mouse();
#ifdef JOY_TYPE_4BUTTON
  if (!stricmp(getenv("WHICH_MACHINE"),"Love_PC2"))
    install_joystick(JOY_TYPE_4BUTTON);
  else
#endif
    install_joystick(JOY_TYPE_AUTODETECT);


  LOCK_VARIABLE(t1);
  LOCK_FUNCTION(timer_click);
  install_int_ex(timer_click,BPS_TO_TIMER(timer_speed));

  set_color_depth(8);
  if (set_gfx_mode(vm,640,480,0,0)) {
    allegro_message(allegro_error);
    exit(1);
  }
  make_palettes();
  set_palette1(normal_pal);
  buf=create_bitmap(SCREEN_W,SCREEN_H);
  asc_bmp=create_bitmap(SCREEN_W,SCREEN_H);


  reserve_voices(4,8);
  if (install_sound(DIGI_AUTODETECT,MIDI_AUTODETECT,NULL)) {
    allegro_message(allegro_error);
  }
  set_uformat(U_ASCII);

  read_pages();

  DF=load_datafile("font.dat");
  for (j=0; DF[j].type==DAT_FONT; j++) {
    FONT *f=(FONT*)DF[j].dat;
    FONT_GLYPH *g= mono_find_glyph(f,' ');
    if (g) g->w/=2;
  }
  DM=load_datafile("music.dat");

  scale=1.0;  OX=OY=0;
  srand(time(NULL));
}

// ----------------- all Drawing -----------------------



#define cw 16
#define ch 20
#define aw 40
#define ah 24
#define M(a) (int)((a)/scale)
#define Mx(a) (M(a-OX)+SCREEN_W/2)
#define My(a) (M(a-OY)+SCREEN_H/2)
#define plot(x,y,c) plot1(Mx(x)/cw,My(y)/ch,c)

char asc[ah][aw];

void plot1(int x,int y,char c)
{ if (x>=0 && x<aw && y>0 && y<ah) asc[y][x]=c; }

void draw(bool edit,bool ascii)
{

  int j,k,poly[14];
  fix dx,dy,s,sx,sy,x,y,len,wid, ang;
  char c;
  clear_to_color(buf,2);

  memset(asc,' ',sizeof(asc));

  for (j=0;j<n_edges;j++) {
    Edge &e=E[j];
    if (ascii) {
      if (e.type==2) c='#';
      else {
        if (Abs(cos(e.dir))>0.9) c='-';
        else if (Abs(sin(e.dir))>0.9) c='|';
        else if (tan(e.dir)>0) c='\\';
        else c='/';
      }
      for (s=0; s<1; s+=10/e.l) {
        x= (1-s)*e.n1->x + s*e.n2->x;
        y= (1-s)*e.n1->y + s*e.n2->y;
        plot(x,y,c);
      }
    }

    if (e.type==1) {
      dx=1.5*sin(e.dir);
      dy=-1.5*cos(e.dir);
      poly[0]=Mx(e.n1->x+dx); poly[1]=My(e.n1->y+dy);
      poly[2]=Mx(e.n1->x-dx); poly[3]=My(e.n1->y-dy);
      poly[4]=Mx(e.n2->x-dx); poly[5]=My(e.n2->y-dy);
      poly[6]=Mx(e.n2->x+dx); poly[7]=My(e.n2->y+dy);
     polygon(buf,4,poly,0);
    } else {
      dx=3.5*sin(e.dir);
      dy=-3.5*cos(e.dir);
      line(buf,Mx(e.n1->x+dx),My(e.n1->y+dy),Mx(e.n2->x+dx),My(e.n2->y+dy),0);
      line(buf,Mx(e.n1->x-dx),My(e.n1->y-dy),Mx(e.n2->x-dx),My(e.n2->y-dy),0);
      for (s=0;s<e.l;s+=3) {
        sx=e.n1->x+s*cos(e.dir);
        sy=e.n1->y+s*sin(e.dir);
        line(buf,Mx(sx+dx),My(sy+dy),Mx(sx-dx),My(sy-dy),0);
      }
    }
    if (j==cur_edge) circlefill(buf,Mx(e.x),My(e.y),5,0);
    else if (j==close_edge && -1==close_node)
      circlefill(buf,Mx(e.x),My(e.y),5,13);
  }

  for (j=0;j<n_nodes;j++) {
    Node &n=N[j];
    if (ascii) {
      plot(n.x,n.y,'o');
    }
    if (edit) {
      circlefill(buf,Mx(n.x),My(n.y), 5, j==cur_node? 15:(j==close_node?13:12));
    }
  }

  if (!edit) {
    for (j=0;j<n_vehicles;j++) {
      Vehicle &v=V[j];

      if (ascii)
        plot(v.x,v.y,'*');

      len=wid=0;
      v.place();
      switch (v.type) {
        case 1: circlefill(buf,Mx(v.x),My(v.y),7,14);  //bike
        Case 2: circlefill(buf,Mx(v.x),My(v.y),10,13); //dest
        Case 3: circlefill(buf,Mx(v.x),My(v.y),j ? 11:9,j ? 7:15); //car
        Case 4: len=30; wid=10;
      }
      if (len!=0) {
        dx= wid*sin(v.dir);
        dy=-wid*cos(v.dir);
        sx= len*cos(v.dir);
        sy= len*sin(v.dir);
        poly[0]=Mx(v.x+dx+sx); poly[1]=My(v.y+dy+sy);
        poly[2]=Mx(v.x-dx+sx); poly[3]=My(v.y-dy+sy);
        poly[4]=Mx(v.x-dx-sx); poly[5]=My(v.y-dy-sy);
        poly[6]=Mx(v.x+dx-sx); poly[7]=My(v.y+dy-sy);
        polygon(buf,4,poly,15);
      }

      dx=V[1].x-V[0].x; dy=V[1].y-V[0].y;
      dd = SQi(dx/scale) + SQi(dy/scale);
      if (dd>40000) {
        ang=atan2(dy,dx);
#define P(n,r,t)  poly[n*2  ]=SCREEN_W/2+r*cos(ang)+t*sin(ang);\
                   poly[n*2+1]=SCREEN_H/2+r*sin(ang)-t*cos(ang)
        P(0,180,6); P(1,180,-6); P(2,205,-6); P(3,203,-12);
        P(4,220,0); P(5,203,12); P(6,204,6);
#undef P
        polygon(buf,7,poly,1);
      }

      if (!t2) {
        float tlm;
        switch (era) {
          case 0: tlm=0.65;
          Case 1: tlm=0.75;
          Case 2: tlm=0.7;
          Case 3: tlm=0.5;
          Case 4: tlm=0.45;
        }
        t_limit=(int)( sqrt((float)dd) *tlm)+150;
      }
      textprintf_ex(buf,FD(CN16),20,4,15,-1,"Era %d  Delivery %2d",era,deliv);
      textprintf_ex(buf,FD(CN16),300,4,15,-1,"Time: %2d:%02d",time_left/60/timer_speed,time_left/timer_speed%60);
      textprintf_right_ex(buf,FD(CN16),SCREEN_W-20,4,15,-1,"Score: %4d",score);
    }
    if (ascii) {
      clear_to_color(asc_bmp,0);
      for (k=0; k<ah; k++)
        for (j=0; j<aw; j++)
          textprintf_ex(asc_bmp,FD(CN16),j*cw,k*ch,16,-1,"%c",asc[k][j]);

      textprintf_ex(asc_bmp,FD(CN16),20,4,32,-1,"Era %d  Delivery %2d",era,deliv);
      textprintf_ex(asc_bmp,FD(CN16),300,4,32,-1,"Time: %2d:%02d",time_left/60/timer_speed,time_left/timer_speed%60);
      textprintf_right_ex(asc_bmp,lives_left?FD(CN16):FD(CN24),lives_left?620:430,lives_left?4:330,32,-1,"Score: %4d",score);

      if (!t2) {
        textprintf_ex(asc_bmp,FD(CNB26),100,144,32,-1,"Distance: %d",(int)sqrt((float)dd));
        textprintf_ex(asc_bmp,FD(CNB26),100,184,32,-1,"Time limit: %d:%02d",t_limit/timer_speed/60,t_limit/timer_speed%60);
      } else {
        if (time_left>0)
          textprintf_centre_ex(asc_bmp,FD(CNB26),324,294,32,-1,"Delivered.");
        else {
          if (time_left<-100)
            textprintf_centre_ex(asc_bmp,FD(CNB26),320,204,32,-1,"Gotta look out for them");
          else
            textprintf_centre_ex(asc_bmp,FD(CNB26),320,204,32,-1,"You didn't make it.");
          if (lives_left)
            textprintf_centre_ex(asc_bmp,FD(CNB26),320,254,32,-1,"%d chance%s left.",lives_left, lives_left==1?"":"s");
          else 
            textprintf_centre_ex(asc_bmp,FD(CNB26),320,254,32,-1,"GAME OVER");
        }
      }


      for (k=0;k<SCREEN_H;k++)
        for (j=0;j<SCREEN_W;j++)
          buf->line[k][j]|=asc_bmp->line[k][j];
    }
  }
  scare_mouse();
  BBS;
  unscare_mouse();
}

// ---------------------- Game -----------------------

#define JS(a,b) joy[0].stick[0].axis[a].d##b
#define JB(a) joy[0].button[a].b
#define K(a) key[KEY_##a]

int get_input()
{
  int m1,m2;
  poll_joystick();
  bits - 0 < K(LEFT) < K(RIGHT) < K(UP) < K(DOWN) < K(SPACE);
  m1=bits.n;
  bits - 0 < JS(0,1) < JS(0,2) < JS(1,1) < JS(1,2) < JB(0);
  m2=bits.n;
  return m1|m2;
}
#undef JS
#undef JB
#undef K

void add_v(int type) { V[n_vehicles++].init(type); }

int play_deliv()
{
  int j,k,r=0;

  n_vehicles=0;

  if (!era || era==3 || era==4) add_v(3); else add_v(1); 

  add_v(2);

  for (j=0; j<n_nodes/50; j++) add_v(4);
  if (era>2) for (j=0; j<n_nodes/100; j++) add_v(3);
  t2=0;

  OX = V[0].x; OY = V[0].y;
  if (current_pal!=other_pal) {
    set_palette1(black_palette);
    draw(false,true);
    cross_fade(other_pal,timer_speed/2);
  } else draw(false,true);
  if (readkey()>>8==KEY_ESC) return -1;
  cross_fade(normal_pal,2*timer_speed);

  t1=1;
  do {
    if (t1<=t2) {

      OX = V[0].x; OY = V[0].y;
      draw();

      fts++;
    } else {

      for (j=0;j<n_vehicles;j++) {
        Vehicle &v=V[j];
        if (!j) {
          v.go=get_input();
          if (riding && v.n) {
            if (v.go & stopmove && v.n->ne_type(1))
              riding=0;
          }
        } else {
          if (v.type==3 && SQi(v.x-V[0].x)+SQi(v.y-V[0].y)<100) {
            r=2; t2=t_limit+111; lives_left--;
          }
        }
        if (v.type==4 && v.n && v.n==V[0].n && !riding
            && !(V[0].go & stopmove) && V[0].type==1)
          riding=j;
        if (v.n) v.choose();
        if (v.e) v.slide();
        v.place();
        if (j==riding) {
#define CV(a) V[0].a=v.a
          CV(dir); CV(pos); CV(speed); CV(n); CV(e);
#undef CV
          V[0].place();
        }
      }
      if (V[0].e==V[1].e && Abs(V[0].pos-V[1].pos)*V[0].e->l<10) {
        r=1; score+=time_left;
      }
      if (keypressed()) {
        k=readkey()>>8;
        switch (k) {
          case KEY_ESC: r=-1;
          Case KEY_PGUP: scale*=1.2;
          Case KEY_PGDN: scale/=1.2;
          Case KEY_F12: r=1; score-=MAX(score-500,0);
          Case KEY_F1:  help(); readkey(); t1=t2;
        }
      }
      t2++;
      if (!(t2%timer_speed)) { fps=fts; fts=0; }
      if (!time_left) { r=3; lives_left--; }
    }

  } while (!r);

  draw(false,true);
  cross_fade(other_pal,2*timer_speed);
  readkey();

  return r;
}

void play_game()
{
  int j,r;
  cur_edge=close_edge=cur_node=close_node=-1;

  lives_left=6;
  load_graph();
  score=0;

  for (j=0;j<75;j++) {
    era=j/15; deliv=j%15+1;
    if (deliv==1) {
      play_midi(era==2 ? NULL : (MIDI*)DM[(era&1) ? (era+1)/2: 0].dat,FALSE);
      help(era + E0_TXT);
    }
    r=play_deliv();
    if (r<0 || !lives_left) break;
  }
  if (r==1) {
    help(E9_TXT);
  }
  if (current_pal==other_pal) {
    cross_fade(black_palette,timer_speed/2); set_palette1(normal_pal);
  }
}

// -------------------------- Editor ---------------------

void editor()
{
  int etype=1;
  int j,k=0,d1,d2,old_mb,mb;
  fix mx,my;
  cur_node=cur_edge=-1;

  load_graph();
  show_mouse(screen);

  do {
    draw(true);

    old_mb=mb;
    poll_mouse();
    mx=(mouse_x-SCREEN_W/2+OX)*scale;
    my=(mouse_y-SCREEN_H/2+OY)*scale;
    mb=mouse_b;

    d2=300; close_node=close_edge=-1;
    for (j=0;j<n_edges;j++) {
      d1=SQi(mx-E[j].x)+SQi(my-E[j].y);
      if (d1<d2) { close_edge=j; d2=d1; }
    }
    for (j=0;j<n_nodes;j++) {
      d1=SQi(mx-N[j].x)+SQi(my-N[j].y);
      if (d1<d2) {
        close_node=j; d2=d1;
      }
    }

    if (mb & ~old_mb & 1) {
      if (close_node>=0) { cur_node=close_node; cur_edge=-1; }
      else               { cur_edge=close_edge; cur_node=-1; }
    } else if (mb & ~old_mb & 2) {
      if (cur_node>=0 && close_node>=0 && cur_node!=close_node && !N[cur_node].is_neighbour(&N[close_node])) {
        join(N[cur_node], N[close_node],etype);
      } else if (cur_node==-1) {
        new_node(mx,my);
        cur_node=n_nodes-1;
      }
    }

    while (keypressed()) {
      k=readkey()>>8;
      switch(k) {
        case KEY_UP: OY-=20;
        Case KEY_DOWN:OY+=20;
        Case KEY_LEFT: OX-=20;
        Case KEY_RIGHT: OX+=20;
        Case KEY_PGUP: scale*=1.2;
        Case KEY_PGDN: scale/=1.2;

        Case KEY_1: if (cur_edge>=0) E[cur_edge].type=etype=1;
        Case KEY_2: if (cur_edge>=0) E[cur_edge].type=etype=2;

        Case KEY_DEL: if (cur_edge>=0) delete_edge(E[cur_edge]);
                      if (cur_node>=0) delete_node(cur_node);
                      cur_edge=cur_node=-1;
      }
    }
  } while(k!=KEY_ESC); 
  
  show_mouse(NULL);
  save_graph();
}

void cleanup()
{
  destroy_bitmap(menu_buf);
  destroy_bitmap(buf);
  destroy_bitmap(asc_bmp);
  unload_datafile(DF);
  unload_datafile(DM);
}

// ---------------------- MAIN ------------------------------

int main(int argc,char **argv)
{
  int r,j,vm=GFX_AUTODETECT;
 
  for (j=1; j<argc; j++) {
    if (!strcmp(argv[j],"-w")) vm=GFX_AUTODETECT_WINDOWED;
    if (!strcmp(argv[j],"-f")) vm=GFX_AUTODETECT_FULLSCREEN;
  }

  init(vm);

  menu_buf=create_bitmap(300,170);
  menu_font=FD(CN16);

  MenuList ml,ml1,ml2;
  MenuItem i1("Play Game!",4),  i2("Editor",2),
     i8("About",7), i5("Quit",-1);
  ml << i1  << i2 << i8 << i5;
  MenuSet ms(&ml);
  ms.linecol   =10;
  ms.wordcol0  =15;
  ms.wordcol1  =15;
  ms.wordcol2  =15;
  ms.hilightcol=12;

  do {
    clear_to_color(buf,0);
    clear_to_color(menu_buf,0);

    ms.Draw(menu_buf);
//    blit(menu_buf,buf,0,0,0,100,menu_buf->w,menu_buf->h);
    draw_sprite(buf,menu_buf,150,240);
    textout_centre_ex(buf,FD(CNB26),"We Deliver.",320,10,11,-1);
    textout_centre_ex(buf,FD(CN18),"On Time.",320,48,11,-1);
    textout_centre_ex(buf,FD(CN18),"Any Time.",320,68,11,-1);
    textout_centre_ex(buf,FD(CN18),"by Eric Love",320,131,14,-1);
    textout_centre_ex(buf,FD(CN18),"a game for TINS '06",320,160,14,-1);
    BBS;

    r=ms.OnKey(readkey());

    switch(r) {
      case 4: play_game(); while (keypressed()) readkey();
      Case 2: editor();    while (keypressed()) readkey();
      Case 7: help(TA_TXT);while (keypressed()) readkey();
    }
  } while (r!=-1);

  cleanup();
  return 0;
}
END_OF_MAIN();

