#ifndef WEDEL_H
#define WEDEL_H

#include <allegro.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
// Some machines need <memory.h> instead of string?
#include "menu.h"
#include "text.h"
#include "font.h"

#ifndef PI
#define PI 3.14159
#endif
#define SQ(a) ((a)*(a))
#define SQi(a) SQ((int)(a))
#define Abs(a) ((a)<0 ? -(a) : (a))
//#define MAX(a,b) ((a)>(b) ? (a) : (b))
#define Case break; case
#define Default break; default
#define keySHIFT (key[KEY_LSHIFT] || key[KEY_RSHIFT])

#define BBS blit(buf,screen,0,0,0,0,SCREEN_W,SCREEN_H)

#define FD(a) ((FONT*)DF[a##_PCX].dat)


enum { leftmove=0x1,  rightmove=0x2, upmove=0x4, downmove=0x8,
        stopmove=0x10 };

struct Bits                    
{
  unsigned int n,i;
  Bits& operator- (int ii) { n=0; i=ii; return *this; }
  Bits& operator< (bool b) { if (b) n|=(1 << i); i++; return *this; }
};
extern Bits bits;

extern volatile int t1;
extern int t2,t3, fts,fps;
extern int timer_speed;

void timer_click();

extern DATAFILE *DF;

struct Node;

struct Edge
{
  Node *n1,*n2;
  int type,c1;
  fix x,y,l,dir;
};

struct Node
{
  fix x,y;
  char s[20];
  Edge *e[10];
  int ne,id;

  void operator + (Edge &e1);
  void operator - (Edge *e1);
  bool is_neighbour(Node *n);
  int ne_type(int t);
};

struct Vehicle
{
  Edge *e; Node *n;
  fix pos, speed, dir, x,y;
  int type;
  int go;

  void place();
  Edge* choose_random();
  Edge* choose_go();
  void choose();
  void slide();
  void init(int t);
};

Node &new_node(fix x1,fix y1);
void delete_node(int i);
void delete_edge(Edge &e);
int num_edges(Edge &e);
bool has_leaf(Edge &e);
Edge &join(Node *n1,Node *n2,int type);
Edge &join(Node &n1,Node &n2,int type);

extern int n_edges, n_nodes, n_vehicles;
extern Edge E[2000]; extern Node N[2000]; extern Vehicle V[200];

extern fix scale,OX,OY;
extern BITMAP *buf;

extern PALETTE normal_pal,other_pal, xf_pal;
extern RGB *current_pal;

int hcf(int n1,int n2);
void save_graph();
void load_graph();

void make_palettes();
void set_palette1(PALETTE p);
void cross_fade(PALETTE too,int length);

struct Letter
{
  char l;
  int fx,fy,tx,ty,x,y;

  void calc(int t);
};

struct Page
{
  static const int height=14,width=40;

  char a[height][width];
  int hm[256],l;

  void get_text(const char *s,int l=-1);
  void draw();
};

struct Pages
{
  Page *p1,*p2;
  int hm[256],chm[256],n;
  Letter l[5000];

  void init(Page *a1,Page *a2);
  void draw(int t);
  void smove();
};

void help(int i=-1);

extern int cur_node,cur_edge, close_node,close_edge;

void init(int vm);
void draw(bool edit=false,bool ascii=false);
void play_game();
void editor();


#endif

